#ifndef UART_COM_HPP
#define UART_COM_HPP

/**
 * @file UARTCom.hpp
 * @author your name (you@domain.com)
 * @brief class to manage uart communication
 * @version 0.1
 * @date 2021-07-22
 * 
 * @copyright Copyright (c) 2021
 * 
 */

#include "Arduino.h"
#include "constants.h"

class UARTCom {
private:
	/* functions */

public:
	/* variables */
	static uint8_t data[MAX_PACKET_LENGTH];

	/* functions */

	/**
	 * @brief 			initializes uart communication
	 * 
	 * @param d			data package to be initialized
	 */
	static void init (uint8_t* d);

	/**
	 * @brief 			reads uart interface and stores the data into an uint8_t array
	 * 
	 * @param d 		array to store the data into
	 */
	static void read (uint8_t* d);

	/**
	 * @brief 			assembles and sends a uart package
	 * 
	 * @param ft 		frametype of message
	 * @param pll 		payload length
	 * @param c 		component
	 * @param pl 		payload
	 */
	static void send (U_FrameType ft, uint8_t pll, U_Component c, uint8_t* pl);
};

#endif