#ifndef U_COMMANDS_HPP
#define U_COMMANDS_HPP

/**
 * @file UCommands.hpp
 * @author your name (you@domain.com)
 * @brief implementation of commands according to uart protocol
 * @version 0.1
 * @date 2021-07-22
 * 
 * @copyright Copyright (c) 2021
 * 
 */

#include "Arduino.h"
#include "constants.h"

class UCommands {
private:
	/* functions */

public:
	/* variables */

	/* functions */

	/**
	 * @brief 			sets the desired velocity of a motor
	 * 
	 * @param d 		uart data package to read the velocity from
	 * @param c 		motor to apply the value to
	 */
	static void setSetpoint (uint8_t* d, U_Component c);
	/**
	 * @brief 			sets the PID parameters
	 * 
	 * @param d 		uart data package to read the pid parameters from
	 * @param c 		motor to apply the value to
	 */
	static void setPIDParameter(uint8_t* d, U_Component c);
};

#endif