#ifndef UTILS_HPP
#define UTILS_HPP

/**
 * @file Utils.hpp
 * @author your name (you@domain.com)
 * @brief useful converting and computing functions
 * @version 0.1
 * @date 2021-07-22
 * 
 * @copyright Copyright (c) 2021
 * 
 */

#include "Arduino.h"
#include "R2WD.h"

class Utils {
private:
	/* functions */

public:
	/* variables */

	/* functions */

	/**
	 * @brief 		converts 4 bytes to float (big endian)
	 * 
	 * @param b0 	first byte
	 * @param b1 	second byte
	 * @param b2 	third byte
	 * @param b3 	fourth byte
	 * @return float 
	 */
	static float bytesToFloat (uint8_t b0, uint8_t b1, uint8_t b2, uint8_t b3);

	/**
	 * @brief 		converts 4 bytes to uint32_t (big endian)
	 * 
	 * @param b0 	first byte
	 * @param b1 	second byte
	 * @param b2 	third byte
	 * @param b3 	fourth byte
	 * @return uint32_t 
	 */
	static uint32_t bytesToInt (uint8_t b0, uint8_t b1, uint8_t b2, uint8_t b3);
};

#endif