#include "communication/UValue.hpp"
#include "communication/UARTCom.hpp"
#include "Arduino.h"
#include "communication/UValue.hpp"
#include "constants.h"

void UValue::sendEncoderValue (U_Component cp, float value)
{
	union {
		float f;
		uint8_t b[4];
	} u;
	u.f = value;
	uint8_t switched_b[4];
	for (int i = 0; i < 4; i++) {
		switched_b[i] = u.b[3 - i];
	}

	UARTCom::send(VALUE, 4, cp, switched_b);
}

void UValue::sendBothEncoderValues (float value_right, float value_left)
{
	union {
		float f[2];
		uint8_t b[8];
	} u;
	u.f[0] = value_right;
	u.f[1] = value_left;

	uint8_t switched_byte_array[8];
	for (int i = 0; i < 4; i++) {
		switched_byte_array[i] = u.b[3 - i];
		switched_byte_array[i+4] = u.b[7 - i];
	}

	UARTCom::send(VALUE, 8, ALL_MOTORS, switched_byte_array);
}