from pathlib import Path

from launch import LaunchDescription
from launch.actions import IncludeLaunchDescription
from launch.launch_description_sources import PythonLaunchDescriptionSource
from launch_ros.actions import Node
from ament_index_python import get_package_share_directory


def generate_launch_description():
    return LaunchDescription(
        [
            IncludeLaunchDescription(
                PythonLaunchDescriptionSource(
                    str(Path(__file__).parent.absolute() / "remote_control_launch.py")
                )
            ),
            IncludeLaunchDescription(
                PythonLaunchDescriptionSource(
                    str(
                        (
                            Path(
                                get_package_share_directory("turtlebot3_gazebo")
                            ).absolute()
                            / "launch"
                            / "turtlebot3_world.launch.py"
                        )
                    )
                )
            ),
            IncludeLaunchDescription(
                PythonLaunchDescriptionSource(
                    str(
                        (
                            Path(get_package_share_directory("slam_toolbox")).absolute()
                            / "launch"
                            / "online_async_launch.py"
                        )
                    )
                ),
                launch_arguments=[("use_sim_time", "True")],
            ),
        ]
    )
